// Generated by CoffeeScript 1.8.0
(function() {
  define(['chai', 'backbone', 'backbone-dom-view'], function(_arg, Backbone, DomView) {
    var expect, model;
    expect = _arg.expect;
    model = null;
    beforeEach(function() {
      return model = new Backbone.Model();
    });
    return describe('class, prop, attr, style, html helpers', function() {
      it('should toggle class for model events', function() {
        var View, el, view;
        View = DomView.extend({
          template: {
            '': {
              "class": {
                'cTest': 'test eventName'
              },
              prop: {
                'pTest': 'test eventName'
              },
              attr: {
                'aTest': 'test eventName'
              },
              style: {
                'opacity': 'test eventName'
              },
              html: 'test eventName'
            }
          }
        });
        view = new View({
          model: model
        });
        el = view.$el;
        expect(el).not.to.have["class"]('aTest');
        expect(el).not.to.have.prop('pTest');
        expect(el).not.to.have.attr('aTest');
        expect(el).to.have.css('opacity', '1');
        expect(el).to.be.empty;
        model.trigger('test', 1);
        expect(el).to.have["class"]('cTest');
        expect(el).to.have.prop('pTest', 1);
        expect(el).to.have.attr('aTest', '1');
        expect(el).to.have.css('opacity', '1');
        expect(el).to.have.html('1');
        model.trigger('eventName', 0);
        expect(el).not.to.have["class"]('aTest');
        expect(el).to.have.prop('pTest', 0);
        expect(el).to.have.attr('aTest', '0');
        expect(el).to.have.css('opacity', '0');
        return expect(el).to.have.html('0');
      });
      it('should toggle class for model events with changed arg number |arg(1)', function() {
        var View, el, view;
        View = DomView.extend({
          template: {
            '': {
              "class": {
                'cTest': 'test|arg(1) eventName|arg(2)'
              },
              prop: {
                'pTest': 'test|arg(1) eventName|arg(2)'
              },
              attr: {
                'aTest': 'test|arg(1) eventName|arg(2)'
              },
              style: {
                'opacity': 'test|arg(1) eventName|arg(2)'
              },
              html: 'test|arg(1) eventName|arg(2)'
            }
          }
        });
        view = new View({
          model: model
        });
        el = view.$el;
        expect(el).not.to.have["class"]('aTest');
        expect(el).not.to.have.prop('pTest');
        expect(el).not.to.have.attr('aTest');
        expect(el).to.have.css('opacity', '1');
        expect(el).to.be.empty;
        model.trigger('test', false, 1);
        expect(el).to.have["class"]('cTest');
        expect(el).to.have.prop('pTest', 1);
        expect(el).to.have.attr('aTest', '1');
        expect(el).to.have.css('opacity', '1');
        expect(el).to.have.html('1');
        model.trigger('eventName', true, true, 0);
        expect(el).not.to.have["class"]('aTest');
        expect(el).to.have.prop('pTest', 0);
        expect(el).to.have.attr('aTest', '0');
        expect(el).to.have.css('opacity', '0');
        return expect(el).to.have.html('0');
      });
      it('should toggle class for model field @fieldName', function() {
        var View, el, view;
        View = DomView.extend({
          template: {
            '': {
              "class": {
                'cTest': '@test'
              },
              prop: {
                'pTest': '@test'
              },
              attr: {
                'aTest': '@test'
              },
              style: {
                'opacity': '@test'
              },
              html: '@test'
            }
          }
        });
        model.set('test', true);
        view = new View({
          model: model
        });
        el = view.$el;
        expect(el).to.have["class"]('cTest');
        expect(el).to.have.prop('pTest');
        expect(el).to.have.attr('aTest');
        expect(el).to.have.css('opacity');
        expect(el).to.have.html('true');
        model.set('test', 0);
        expect(el).not.to.have["class"]('aTest');
        expect(el).to.have.prop('pTest', 0);
        expect(el).to.have.attr('aTest', '0');
        expect(el).to.have.css('opacity', '0');
        expect(el).to.have.html('0');
        model.set('test', 1);
        expect(el).to.have["class"]('cTest');
        expect(el).to.have.prop('pTest', 1);
        expect(el).to.have.attr('aTest', '1');
        expect(el).to.have.css('opacity', '1');
        return expect(el).to.have.html('1');
      });
      it('should toggle class for view event #viewEvent', function() {
        var View, el, view;
        View = DomView.extend({
          template: {
            '': {
              "class": {
                'cTest': '#test #eventName|arg(1)'
              },
              prop: {
                'pTest': '#test #eventName|arg(1)'
              },
              attr: {
                'aTest': '#test #eventName|arg(1)'
              },
              style: {
                'opacity': '#test #eventName|arg(1)'
              },
              html: '#test #eventName|arg(1)'
            }
          }
        });
        view = new View;
        el = view.$el;
        expect(el).not.to.have["class"]('aTest');
        expect(el).not.to.have.prop('pTest');
        expect(el).not.to.have.attr('aTest');
        expect(el).to.have.css('opacity', '1');
        expect(el).to.be.empty;
        view.trigger('test', 1);
        expect(el).to.have["class"]('cTest');
        expect(el).to.have.prop('pTest', 1);
        expect(el).to.have.attr('aTest', '1');
        expect(el).to.have.css('opacity', '1');
        expect(el).to.have.html('1');
        view.trigger('eventName', true, 0);
        expect(el).not.to.have["class"]('aTest');
        expect(el).to.have.prop('pTest', 0);
        expect(el).to.have.attr('aTest', '0');
        expect(el).to.have.css('opacity', '0');
        return expect(el).to.have.html('0');
      });
      it('should toggle class for function', function() {
        var View, el, view;
        View = DomView.extend({
          template: {
            '': {
              "class": {
                'cTest': {
                  'test': function() {
                    return this.model.get('field');
                  }
                }
              },
              prop: {
                'pTest': {
                  'test': function() {
                    return this.model.get('field');
                  }
                }
              },
              attr: {
                'aTest': {
                  'test': function() {
                    return this.model.get('field');
                  }
                }
              },
              style: {
                'opacity': {
                  'test': function() {
                    return this.model.get('field');
                  }
                }
              },
              html: {
                'test': function() {
                  return this.model.get('field');
                }
              }
            }
          }
        });
        view = new View({
          model: model
        });
        el = view.$el;
        expect(el).not.to.have["class"]('aTest');
        expect(el).not.to.have.prop('pTest');
        expect(el).not.to.have.attr('aTest');
        expect(el).to.have.css('opacity', '1');
        expect(el).to.be.empty;
        model.set('field', 1);
        model.trigger('test');
        expect(el).to.have["class"]('cTest');
        expect(el).to.have.prop('pTest', 1);
        expect(el).to.have.attr('aTest', '1');
        expect(el).to.have.css('opacity', '1');
        expect(el).to.have.html('1');
        model.set('field', '');
        model.trigger('test');
        expect(el).not.to.have["class"]('aTest');
        expect(el).to.have.prop('pTest', '');
        expect(el).to.have.attr('aTest', '');
        expect(el).to.have.css('opacity', '1');
        return expect(el).to.be.empty;
      });
      return it('should react on view event with function', function() {
        var View, el, view;
        View = DomView.extend({
          template: {
            '': {
              prop: {
                'pTest': {
                  'test #vtest': function() {
                    return this.model.get('field');
                  }
                }
              },
              html: {
                'test #vtest': function() {
                  return this.model.get('field');
                }
              }
            }
          }
        });
        view = new View({
          model: model
        });
        el = view.$el;
        expect(el).not.to.have.prop('pTest');
        expect(el).to.be.empty;
        model.set('field', 1);
        model.trigger('test');
        expect(el).to.have.prop('pTest', 1);
        expect(el).to.have.html('1');
        model.set('field', '2');
        view.trigger('vtest');
        expect(el).to.have.prop('pTest', '2');
        return expect(el).to.have.html('2');
      });
    });
  });

}).call(this);
